*:*****************************************************************************
*:
*: Procedure file: D:\FPD26\EZ\EZ_DBCLK.PRG
*:
*:         System: EZ Data Manager
*:         Author: Jack Hairston (209) 572-2634
*:      Copyright (c) 12-25-94, Jack Hairston
*:  Last modified: 12/16/94      6:41
*:
*:         Set by: EZ_IBROW.PRG                      
*:               : EZ_BROW.PRG                       
*:
*:      Documented 12/25/94 at 19:41               FoxDoc  version 2.10f
*:*****************************************************************************
* Syntax  | ON KEY LABEL MOUSE DO ez_dbclk
* Action  | Keyboard a Ctrl-W if double-click.  Selects current record in BROWSE.
* Env In  | _DBLCLICK     System memvar; sets double-click speed.
* Process | gaStack[]     Stack of mouse clicks.
*         |        [1]    SECONDS() of latest mouse click.
*         |        [2]    SECONDS() of previous mouse click.
* Note  1 | Mouse clicks are unusual in that they do their mousey thing
*         | after the mouse click is trapped by an OKL.  So if you click
*         | on a row in the browse, the cursor will move to that row
*         | after this procedure executes.
*       2 | AINS() returns 1 for successful insertion.  This gives several
*         | operations in one line:
*         |   Insert SECONDS() in gaStack[1].
*         |   Push the former value from gaStack[1] to gaStack[2].
*         |   Send gaStack[2] to alphabet heaven.
*         | Don't you just love simple, elegant code? <grin>
*       3 | Other schemes depend on using the BROWSE WHEN clause, which is not
*         | activated when you click (or double-click) on the current record.
*         | Customers hate it when an operation ALMOST works right.
*       4 | Don't forget to turn off the OKL which calls this procedure.
* Concept | Eric Taylor (76177,1563)
*--

*-- Make sure the stack array exists
IF TYPE( "gaStack" ) = "U"
  PUBLIC gastack[ 2 ]
  gastack = 0                             && initialize both rows
ENDIF

gastack[ AINS( gaStack, 1 )] = SECONDS()  && push latest time onto top of stack
IF gastack[1] - gastack[2] <= _DBLCLICK   && check for double click
  KEYBOARD CHR( 23 ) PLAIN                && exit the browse at the current record
ENDIF
*: EOF: EZ_DBCLK.PRG
